/*
  main.cpp
  Copyright (C) 2010 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of radiko-player.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>

#ifdef QWS
#include <qpe/qpeapplication.h>
#else
#include <qapplication.h>
#endif
#include "mainwindow.h"

QApplication *pApp;
MainWindow *pMainWindow;

int main(int argc, char **argv)
{
#ifdef QWS
	QPEApplication app(argc, argv);
	pMainWindow = new MainWindow(NULL, "MainWindow");

	app.showMainWidget(pMainWindow);
#else
	QApplication app(argc, argv);
	pMainWindow = new MainWindow(NULL, "MainWindow");

	app.setMainWidget(pMainWindow);
	pMainWindow->show();
#endif

	pApp = &app;

	int ret = app.exec();

	delete pMainWindow;
	return ret;
}
