/*
  process.cpp
  Copyright (C) 2010 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of radiko-player.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include "process.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <qstring.h>

Process::Process(QString cmd)
	: timer(this)
{
	run = false;
	this->cmd = cmd;
	connect(&timer, SIGNAL(timeout()),
			this, SLOT(check_process()));
}

Process::~Process()
{
	stop();
}

void Process::setCommand(QString cmd)
{
	this->cmd = cmd;
}

void Process::start()
{
	int p;

//	printf("start\n");

	if (run)
		stop();

#if 0
	if ((p = fork()) == 0) {
		/* child */
		int ret;
		char command[1024];
		char *argv[] = {
			"sh",
			"-c",
			command,
			NULL,
		};

		setpgid(0, 0);
		printf("c getpgrp = %d\n", getpgrp());

		strcpy(command, cmd.latin1());

		execve("sh", argv, NULL);
		exit(ret);
		/* no return */
	}
#else
	system((cmd + "&").latin1());
#endif
	/* parent */
	pid = p;

//	timer.start(1000);

	emit started();
	run = true;
}

void Process::stop()
{
	if (!run)
		return;

//	killpg(pid, 9);
	system("killall -9 mplayer");
	run = false;
	timer.stop();
	emit exited(0);
}

void Process::wait()
{
	if (!run)
		return;

	timer.stop();
//	printf("wait child pid = %d\n", pid);
//	waitpid(pid, &status, 0);
//	printf("exit child pid = %d status = %d\n", pid, status);
}

void Process::check_process()
{
//	printf("check_process\n");
#if 0
	if (waitpid(pid, &status, WNOHANG) > 0) {
		run = false;
		timer.stop();
//		printf("check_process: exit child pid = %d status = %d\n", pid, status);

		emit exited(status);
	}
#endif
}
