/*
  process.h
  Copyright (C) 2010 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of radiko-player.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __PROCESS_H__
#define __PROCESS_H__

#include <qtimer.h>
#include <qstring.h>
#include <qobject.h>

class Process : public QObject
{
  Q_OBJECT
  public:
	Process(QString cmd=0);
	~Process();

	void setCommand(QString cmd);

	void start();
	void stop();
	void wait();

  private:
	bool run;
	int pid;
	int status;
	QTimer timer;
	QString cmd;

  protected slots:
	void check_process();

  signals:
	void started();
	void exited(int status);
};

#endif /* __PROCESS_H__ */
